/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20240109

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 36 "hfp_parser.y"
/*
********************************************************************************
* Include files
********************************************************************************
*/

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <inttypes.h>
#include <string.h>
#include "hfp_lexer.h"
/* Do not include the generated header file here */
#include "hfp_parser_external.h"


/*
********************************************************************************
* Constants
********************************************************************************
*/

#define yyerror cl_hfp_yyerror
#define yylex cl_hfp_yylex
#define yyparse cl_hfp_yyparse

#define CL_DEBUG2  0               /* Maximum debug messages if nonzero */


/*
********************************************************************************
* Data types
********************************************************************************
*/

enum cl_type
{
   CL_TYPE_INVALID,
   CL_TYPE_LOCK,
   CL_TYPE_KEY
};

/* Event list element */
struct element_list
{
   const char *estring;            /* Element string */
   struct element_list *next;      /* Pointer to next entry in linked list */
};


/*
********************************************************************************
* Macros
********************************************************************************
*/

#define DEBUG(...) \
{ \
   snprintf(debug_sbuf, 81, __VA_ARGS__); \
   debug(debug_sbuf); \
}

#define DEBUG2(...) \
{ \
   if (CL_DEBUG2) \
   { \
      snprintf(debug_sbuf, 81, __VA_ARGS__); \
      debug(debug_sbuf); \
   } \
}

#define FREE(p) \
{ \
   free((void *) p); \
}

#define ERROR_HANDLER(p) \
{ \
   if (NULL == p) \
   { \
      yyerror("Internal error"); \
      YYABORT; \
   } \
}


/*
********************************************************************************
* Variables
********************************************************************************
*/

static char debug_sbuf[81];
static char *p;
enum cl_type type;                 /* Header field type */
static struct element_list *elements;


/*
********************************************************************************
* Forward declarations
********************************************************************************
*/

void parser_init(void);
static void debug(char *);
static char *dyn_alloc(const char *);
static void check_obsolete_scheme(char *);
static char *str_append(char *, char *);
static char *element_append(char *);
static char *print_output_data(void);

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 150 "hfp_parser.y"
typedef union YYSTYPE
{
   uint8_t num;                    /*!< Integer constant (or unused value) */
   char *str;                      /*!< String */
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 150 "hfp_parser.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define T_ERROR 257
#define T_LOCK 258
#define T_KEY 259
#define T_SCHEME 260
#define T_BASE64 261
#define T_BASE64Q 262
#define T_SP 263
#define T_HT 264
#define T_CTEXT 265
#define T_BS 266
#define T_OBS_NO_WS_CTL 267
#define P_LOWEST 268
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    1,    1,    5,    6,    6,    6,    6,    4,
    4,    7,    9,    9,    8,    8,    8,    8,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   10,   10,   10,   10,   10,   10,   10,    2,   13,   13,
   12,   12,   12,   14,   14,   15,   15,   15,   16,   16,
   18,   18,   17,   19,    3,   21,   21,   20,   20,   20,
   22,   22,   23,   23,   23,   23,   24,   24,
};
static const YYINT yylen[] = {                            2,
    0,    1,    1,    1,    1,    1,    2,    1,    2,    1,
    1,    3,    1,    2,    0,    1,    1,    1,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    1,    1,    1,    1,    1,    1,    1,    4,    1,    2,
    1,    2,    2,    2,    3,    1,    2,    1,    1,    2,
    4,    4,    1,    1,    4,    1,    2,    1,    2,    2,
    2,    3,    1,    1,    2,    2,    1,    1,
};
static const YYINT yydefred[] = {                         0,
    0,    0,    0,    2,    3,    4,    0,    0,    0,    0,
    0,   10,   11,    0,    6,    0,    0,    8,    0,   38,
   41,    0,    0,    0,   55,   58,    0,   37,   35,   36,
   32,   33,   34,    0,   31,   16,   13,    0,   17,   18,
    0,    7,    9,   43,   42,    0,    0,   60,   59,   54,
   53,   45,    0,   49,   48,    0,   30,   28,   29,   20,
   21,   24,   25,   27,   22,   23,   26,   19,   12,   14,
   68,    0,   67,    0,   64,   50,   47,    0,    0,   66,
    0,    0,   52,   51,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
  258,  259,  270,  271,  272,  273,   58,   58,  263,  263,
  260,  263,  264,   40,  274,  275,  276,  277,  282,  283,
  284,  260,  275,  290,  291,  292,   58,  260,  261,  262,
   58,   61,  265,  266,  267,  275,  278,  279,  280,  281,
  282,  274,  277,  275,  284,   58,  290,  275,  292,  261,
  262,  285,  286,  287,  288,  289,  260,  261,  262,  263,
  264,   58,   61,  265,   40,   41,  266,  267,   41,  278,
   61,  286,  289,  293,  294,  287,  288,  289,  286,  294,
   61,  289,   61,   61,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                          3,
    4,    5,    6,   15,   36,   17,   18,   37,   38,   39,
   40,   19,   20,   21,   52,   53,   54,   55,   56,   24,
   25,   26,   74,   75,
};
static const YYINT yysindex[] = {                      -252,
  -50,  -48,    0,    0,    0,    0, -239, -231,  -11,   -9,
  -39,    0,    0,  -20,    0, -220,   -6,    0,  -11,    0,
    0,  -15, -216,   -9,    0,    0, -244,    0,    0,    0,
    0,    0,    0,  -36,    0,    0,    0,  -28,    0,    0,
  -11,    0,    0,    0,    0,  -61,   -9,    0,    0,    0,
    0,    0, -244,    0,    0, -214,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -211,    0,  -61,    0,    0,    0,  -59, -211,    0,
   -1,    3,    0,    0,
};
static const YYINT yyrindex[] = {                        52,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   24,    0,    0,    1,    0,   55,    0,
    0,    0,    0,   57,    0,    0,   16,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,    0,    0,   21,   69,    0,    0,    0,
    0,    0,   23,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    9,    0,   28,    0,    0,    0,    0,   14,    0,
    0,    0,    0,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
    0,    0,    0,   54,   26,    0,   60,   34,    0,    0,
    0,   58,    0,   -4,    0,  -35,  -26,   25,    2,   56,
    0,  -21,    0,    7,
};
#define YYTABLESIZE 292
static const YYINT yytable[] = {                         71,
    5,   81,   49,   65,   66,    1,    2,    7,   63,    8,
   72,   14,   69,   65,   45,   44,   50,   51,   27,   14,
   61,   62,   46,    9,   63,   49,   76,   62,   14,   31,
   14,   10,   32,   14,   16,   23,   45,   31,   79,   11,
   32,    5,   46,   22,   44,   76,   50,   73,   63,   48,
   51,    1,   76,   65,   39,   44,   56,   78,    5,   83,
   61,    5,   46,   84,   15,   40,   44,   62,   57,   63,
   42,   70,   48,   41,   65,   73,   43,   77,   47,   82,
   80,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   50,
   51,   50,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   57,   58,   59,   60,   61,   64,   67,
   68,   28,   29,   30,   12,   13,   33,   34,   35,   28,
   29,   30,   12,   13,   33,   34,   35,    0,   11,    0,
   22,   12,   13,   12,   13,    0,   12,   13,    0,    0,
    5,    5,    5,    0,    0,    5,    5,    5,   63,   63,
    0,   63,   63,   65,   65,   44,   65,   65,   44,   44,
   61,    0,   46,   61,   61,   46,   46,   62,    0,    0,
   62,   62,
};
static const YYINT yycheck[] = {                         61,
    0,   61,   24,   40,   41,  258,  259,   58,    0,   58,
   46,   40,   41,    0,   19,    0,  261,  262,   58,   40,
    0,   58,    0,  263,   61,   47,   53,    0,   40,   58,
   40,  263,   61,   40,    9,   10,   41,   58,   74,  260,
   61,   41,   58,  260,   19,   72,  261,   46,   40,   24,
  262,    0,   79,   40,    0,   40,    0,   56,   58,   61,
   40,   61,   40,   61,   41,    0,   41,   40,    0,   61,
   17,   38,   47,   16,   61,   74,   17,   53,   23,   78,
   74,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  261,
  262,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  260,  261,  262,  263,  264,  265,  266,
  267,  260,  261,  262,  263,  264,  265,  266,  267,  260,
  261,  262,  263,  264,  265,  266,  267,   -1,  260,   -1,
  260,  263,  264,  263,  264,   -1,  263,  264,   -1,   -1,
  260,  261,  262,   -1,   -1,  265,  266,  267,  260,  261,
   -1,  263,  264,  260,  261,  260,  263,  264,  263,  264,
  260,   -1,  260,  263,  264,  263,  264,  260,   -1,   -1,
  263,  264,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,
};
#endif
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 268
#define YYUNDFTOKEN 295
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'('","')'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,"'='",0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"error","T_ERROR",
"T_LOCK","T_KEY","T_SCHEME","T_BASE64","T_BASE64Q","T_SP","T_HT","T_CTEXT",
"T_BS","T_OBS_NO_WS_CTL","P_LOWEST","$accept","target","hfield","cancel_lock",
"cancel_key","wsp","cfws","cfws_i","comment","ccontent","ccontent_list","ctext",
"quoted_pair","c_lock_list_i","c_lock_list","c_lock","c_lock_string",
"base64_quads","base64_quad","base64_terminal","base64_char","c_key_list_i",
"c_key_list","c_key","obs_c_key_string","base64_octet","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : target",
"target :",
"target : hfield",
"hfield : cancel_lock",
"hfield : cancel_key",
"cfws : cfws_i",
"cfws_i : wsp",
"cfws_i : cfws_i wsp",
"cfws_i : comment",
"cfws_i : cfws_i comment",
"wsp : T_SP",
"wsp : T_HT",
"comment : '(' ccontent_list ')'",
"ccontent_list : ccontent",
"ccontent_list : ccontent_list ccontent",
"ccontent :",
"ccontent : cfws",
"ccontent : ctext",
"ccontent : quoted_pair",
"quoted_pair : T_BS T_OBS_NO_WS_CTL",
"quoted_pair : T_BS T_SP",
"quoted_pair : T_BS T_HT",
"quoted_pair : T_BS '('",
"quoted_pair : T_BS ')'",
"quoted_pair : T_BS ':'",
"quoted_pair : T_BS '='",
"quoted_pair : T_BS T_BS",
"quoted_pair : T_BS T_CTEXT",
"quoted_pair : T_BS T_BASE64",
"quoted_pair : T_BS T_BASE64Q",
"quoted_pair : T_BS T_SCHEME",
"ctext : T_OBS_NO_WS_CTL",
"ctext : ':'",
"ctext : '='",
"ctext : T_CTEXT",
"ctext : T_BASE64",
"ctext : T_BASE64Q",
"ctext : T_SCHEME",
"cancel_lock : T_LOCK ':' T_SP c_lock_list",
"c_lock_list : c_lock_list_i",
"c_lock_list : cfws c_lock_list_i",
"c_lock_list_i : c_lock",
"c_lock_list_i : c_lock_list_i c_lock",
"c_lock_list_i : c_lock_list_i cfws",
"c_lock : T_SCHEME ':'",
"c_lock : T_SCHEME ':' c_lock_string",
"c_lock_string : base64_quads",
"c_lock_string : base64_quads base64_terminal",
"c_lock_string : base64_terminal",
"base64_quads : base64_quad",
"base64_quads : base64_quads base64_quad",
"base64_terminal : base64_char base64_char base64_char '='",
"base64_terminal : base64_char base64_char '=' '='",
"base64_quad : T_BASE64Q",
"base64_char : T_BASE64",
"cancel_key : T_KEY ':' T_SP c_key_list",
"c_key_list : c_key_list_i",
"c_key_list : cfws c_key_list_i",
"c_key_list_i : c_key",
"c_key_list_i : c_key_list_i c_key",
"c_key_list_i : c_key_list_i cfws",
"c_key : T_SCHEME ':'",
"c_key : T_SCHEME ':' obs_c_key_string",
"obs_c_key_string : base64_quads",
"obs_c_key_string : base64_octet",
"obs_c_key_string : obs_c_key_string base64_quads",
"obs_c_key_string : obs_c_key_string base64_octet",
"base64_octet : base64_char",
"base64_octet : '='",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
#line 627 "hfp_parser.y"
  /* Code section */


/* Print debug message */
static void debug(char*  string)
{
   if (cl_hfp_debugmode)
   {
      fprintf(stderr, "Parser : %s\n", string);
      fflush(stderr);
   }

   return;
}


static char *dyn_alloc(const char *p)
{
   char *res = NULL;

   res = (char *) malloc(strlen(p) + (size_t) 1);
   if (NULL != res)
   {
      strcpy(res, p);
   }

   return res;
}


static void check_obsolete_scheme(char *s)
{
   if (!strcmp("md5", s))
   {
      yyerror("Warning: Obsolete <scheme> detected");
   }
   else if (!strcmp("sha1", s))
   {
      yyerror("Warning: Deprecated <scheme> detected");
   }
   if (cl_hfp_debugmode)
      fflush(stderr);

   return;
}


/*
 * Append string s2 to s1
 *
 * Both, s1 and s2 must be dynamically allocated and are no longer valid after
 * return!
 */
static char *str_append(char *s1, char *s2)
{
   char *res = NULL;

   if (NULL == s1 || NULL == s2)
   {
      yyerror("str_append(): NULL pointer argument");
      if (NULL != s1)
         FREE(s1);
      if (NULL != s2)
         FREE(s2);
   }
   else
   {
      res = (char *) realloc(s1, strlen(s1) + strlen(s2) + (size_t) 1);
      if (NULL == res)
      {
         yyerror("Out of memory");
         FREE(s1);
      }
      else
         strcat(res, s2);
      FREE(s2);
   }

   return res;
}


/*
 * Create new element node and add it to linked list
 *
 * e must be dynamically allocated and is returned as result on success.
 */
static char *element_append(char *e)
{
   char *res = e;
   struct element_list *ne;
   struct element_list *le = elements;

   ne = (struct element_list *)
        malloc(sizeof(struct element_list)
                      + strlen(e) + (size_t) 1);
   if (NULL == ne)
   {
      yyerror("Out of memory");
      FREE(e);
      res = NULL;
   }
   else
   {
      /* Copy e into new node */
      ne->estring = strcpy(&((char *) ne)[sizeof(struct element_list)], e);
      ne->next = NULL;
      /* Check for empty list */
      if (NULL == elements)
         elements = ne;
      else
      {
         while (le->next)
            le = le->next;
         le->next = ne;
      }
   }
   /* e is now part of the linkd list, do not free it */

   return res;
}


/*
 * Print output data
 *
 * Returns non-NULL on success.
 */
static char *print_output_data(void)
{
   char *ret = NULL;
   struct element_list *ce = elements;
   struct element_list *ne;
   uint8_t  notfirst = 0;

   fflush(stderr);
   fflush(stdout);
   if (CL_TYPE_INVALID != type)
   {
      if (cl_hfp_printhfn)
      {
         fprintf(stderr, "   ");
         fflush(stderr);
         if (CL_TYPE_LOCK == type)
         {
            printf("Cancel-Lock: ");
            fflush(stdout);
         }
         else
         {
            printf("Cancel-Key: ");
            fflush(stdout);
         }
         fprintf(stderr, "\n");
         fflush(stderr);
      }
      if (NULL != ce)
         ret = "Success";
      while (NULL != ce)
      {
         fflush(stderr);
         if (notfirst)
         {
            fprintf(stderr, "  ");
            fflush(stderr);
            printf(" ");
            fflush(stdout);
         }
         else
         {
            fprintf(stderr, "   ");
            fflush(stderr);
         }
         printf("%s", ce->estring);
         fflush(stdout);
         fprintf(stderr, "\n");
         fflush(stderr);
         ce = ce->next;
         notfirst = 1;
      }
   }

   /* Clean up */
   ce = elements;
   while (NULL != ce)
   {
      ne = ce->next;
      FREE(ce);
      ce = ne;
   }

   return(ret);
}


/* Init parser */
void cl_hfp_yyinit(void)
{
   type = CL_TYPE_INVALID;
   elements = NULL;

   return;
}


/* EOF */
#line 819 "hfp_parser.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    /* yyn is set below */
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 1:
#line 213 "hfp_parser.y"
	{
      yyerror("No input data");
      YYABORT;
   }
#line 1495 "hfp_parser.c"
break;
case 2:
#line 218 "hfp_parser.y"
	{
      /* Print output data */
      DEBUG("Print output data");
      FREE(yystack.l_mark[0].str);
      p = print_output_data();
      ERROR_HANDLER(p);
   }
#line 1506 "hfp_parser.c"
break;
case 3:
#line 229 "hfp_parser.y"
	{
      type = CL_TYPE_LOCK;
   }
#line 1513 "hfp_parser.c"
break;
case 4:
#line 233 "hfp_parser.y"
	{
      type = CL_TYPE_KEY;
   }
#line 1520 "hfp_parser.c"
break;
case 5:
#line 240 "hfp_parser.y"
	{
      DEBUG("<cfws>");
   }
#line 1527 "hfp_parser.c"
break;
case 7:
#line 248 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1535 "hfp_parser.c"
break;
case 8:
#line 253 "hfp_parser.y"
	{
      FREE(yystack.l_mark[0].str);
      yyval.str = dyn_alloc(" ");
   }
#line 1543 "hfp_parser.c"
break;
case 9:
#line 258 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      FREE(yystack.l_mark[0].str);
      yyval.str = dyn_alloc(" ");
   }
#line 1552 "hfp_parser.c"
break;
case 11:
#line 268 "hfp_parser.y"
	{
      yyval.str = dyn_alloc(" ");
   }
#line 1559 "hfp_parser.c"
break;
case 12:
#line 275 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-2].str);
      FREE(yystack.l_mark[0].str);
      yyval.str = yystack.l_mark[-1].str;
      DEBUG("<comment>");
   }
#line 1569 "hfp_parser.c"
break;
case 14:
#line 286 "hfp_parser.y"
	{
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      yyval.str = p;
   }
#line 1578 "hfp_parser.c"
break;
case 15:
#line 295 "hfp_parser.y"
	{
      yyval.str = dyn_alloc("");
   }
#line 1585 "hfp_parser.c"
break;
case 18:
#line 301 "hfp_parser.y"
	{
      DEBUG("<quoted-pair>");
   }
#line 1592 "hfp_parser.c"
break;
case 19:
#line 308 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1600 "hfp_parser.c"
break;
case 20:
#line 313 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1608 "hfp_parser.c"
break;
case 21:
#line 318 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1616 "hfp_parser.c"
break;
case 22:
#line 323 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1624 "hfp_parser.c"
break;
case 23:
#line 328 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1632 "hfp_parser.c"
break;
case 24:
#line 333 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1640 "hfp_parser.c"
break;
case 25:
#line 338 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1648 "hfp_parser.c"
break;
case 26:
#line 343 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1656 "hfp_parser.c"
break;
case 27:
#line 348 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1664 "hfp_parser.c"
break;
case 28:
#line 353 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
   }
#line 1672 "hfp_parser.c"
break;
case 29:
#line 358 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
      DEBUG("Workaround: Use only first octet of base64 quad");
   }
#line 1681 "hfp_parser.c"
break;
case 30:
#line 364 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
      DEBUG("Workaround: Use only first octet for quoted-pair");
   }
#line 1690 "hfp_parser.c"
break;
case 38:
#line 385 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-3].str);
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-2].str, p);
      ERROR_HANDLER(p);
      p = str_append(dyn_alloc("Cancel-Lock"), p);
      ERROR_HANDLER(p);
      yyval.str = p;
      DEBUG("<cancel-lock>");
   }
#line 1705 "hfp_parser.c"
break;
case 39:
#line 400 "hfp_parser.y"
	{
      DEBUG("<c-lock-list>");
   }
#line 1712 "hfp_parser.c"
break;
case 40:
#line 404 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
      DEBUG("<c-lock-list>");
   }
#line 1721 "hfp_parser.c"
break;
case 41:
#line 413 "hfp_parser.y"
	{
      p = element_append(yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      yyval.str = p;
   }
#line 1730 "hfp_parser.c"
break;
case 42:
#line 419 "hfp_parser.y"
	{
      p = element_append(yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      /* Insert SP separator even if syntax do not require it */
      p = str_append(dyn_alloc(" "), p);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-1].str, p);
      ERROR_HANDLER(p);
      yyval.str = p;
   }
#line 1744 "hfp_parser.c"
break;
case 43:
#line 430 "hfp_parser.y"
	{
      FREE(yystack.l_mark[0].str);
   }
#line 1751 "hfp_parser.c"
break;
case 44:
#line 437 "hfp_parser.y"
	{
      check_obsolete_scheme(yystack.l_mark[-1].str);
      yyval.str = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      DEBUG("<c-lock-string> with zero length");
      DEBUG("<c-lock>");
   }
#line 1761 "hfp_parser.c"
break;
case 45:
#line 444 "hfp_parser.y"
	{
      check_obsolete_scheme(yystack.l_mark[-2].str);
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-2].str, p);
      ERROR_HANDLER(p);
      yyval.str = p;
      DEBUG("<c-lock>");
   }
#line 1774 "hfp_parser.c"
break;
case 46:
#line 457 "hfp_parser.y"
	{
      DEBUG("<c-lock-string>");
   }
#line 1781 "hfp_parser.c"
break;
case 47:
#line 461 "hfp_parser.y"
	{
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      yyval.str = p;
      DEBUG("<c-lock-string>");
   }
#line 1791 "hfp_parser.c"
break;
case 48:
#line 468 "hfp_parser.y"
	{
      DEBUG("<c-lock-string>");
   }
#line 1798 "hfp_parser.c"
break;
case 49:
#line 475 "hfp_parser.y"
	{
      DEBUG2("<base64-quads>");
   }
#line 1805 "hfp_parser.c"
break;
case 50:
#line 479 "hfp_parser.y"
	{
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      yyval.str = p;
      DEBUG2("<base64-quads>");
   }
#line 1815 "hfp_parser.c"
break;
case 51:
#line 489 "hfp_parser.y"
	{
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-2].str, p);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-3].str, p);
      ERROR_HANDLER(p);
      yyval.str = p;
      DEBUG2("<base64-terminal>");
   }
#line 1829 "hfp_parser.c"
break;
case 52:
#line 500 "hfp_parser.y"
	{
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-2].str, p);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-3].str, p);
      ERROR_HANDLER(p);
      yyval.str = p;
      DEBUG2("<base64-terminal>");
   }
#line 1843 "hfp_parser.c"
break;
case 55:
#line 522 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-3].str);
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-2].str, p);
      ERROR_HANDLER(p);
      p = str_append(dyn_alloc("Cancel-Key"), p);
      ERROR_HANDLER(p);
      yyval.str = p;
      DEBUG("<cancel-key>");
   }
#line 1858 "hfp_parser.c"
break;
case 56:
#line 537 "hfp_parser.y"
	{
      DEBUG("<c-key-list>");
   }
#line 1865 "hfp_parser.c"
break;
case 57:
#line 541 "hfp_parser.y"
	{
      FREE(yystack.l_mark[-1].str);
      yyval.str = yystack.l_mark[0].str;
      DEBUG("<c-key-list>");
   }
#line 1874 "hfp_parser.c"
break;
case 58:
#line 550 "hfp_parser.y"
	{
      p = element_append(yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      yyval.str = p;
   }
#line 1883 "hfp_parser.c"
break;
case 59:
#line 556 "hfp_parser.y"
	{
      p = element_append(yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      /* Insert SP separator even if syntax do not require it */
      p = str_append(dyn_alloc(" "), p);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-1].str, p);
      ERROR_HANDLER(p);
      yyval.str = p;
   }
#line 1897 "hfp_parser.c"
break;
case 60:
#line 567 "hfp_parser.y"
	{
      FREE(yystack.l_mark[0].str);
   }
#line 1904 "hfp_parser.c"
break;
case 61:
#line 574 "hfp_parser.y"
	{
      check_obsolete_scheme(yystack.l_mark[-1].str);
      yyval.str = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      DEBUG("<c-lock-string> with zero length");
      DEBUG("<c-key>");
   }
#line 1914 "hfp_parser.c"
break;
case 62:
#line 586 "hfp_parser.y"
	{
      check_obsolete_scheme(yystack.l_mark[-2].str);
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      p = str_append(yystack.l_mark[-2].str, p);
      ERROR_HANDLER(p);
      yyval.str = p;
      DEBUG("<obs-c-key-string>");
      DEBUG("<c-key>");
   }
#line 1928 "hfp_parser.c"
break;
case 65:
#line 602 "hfp_parser.y"
	{
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      yyval.str = p;
   }
#line 1937 "hfp_parser.c"
break;
case 66:
#line 608 "hfp_parser.y"
	{
      p = str_append(yystack.l_mark[-1].str, yystack.l_mark[0].str);
      ERROR_HANDLER(p);
      yyval.str = p;
   }
#line 1946 "hfp_parser.c"
break;
case 67:
#line 617 "hfp_parser.y"
	{
      DEBUG2("<base64-octet>");
   }
#line 1953 "hfp_parser.c"
break;
case 68:
#line 621 "hfp_parser.y"
	{
      DEBUG2("<base64-octet>");
   }
#line 1960 "hfp_parser.c"
break;
#line 1962 "hfp_parser.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
